#include <config.h>
#include <nessus-devel.h>
#include <nessuslib.h>
#include <stdio.h>
#include <ctype.h>
#ifdef HAVE_STRING_H
#include <string.h>
#endif /* HAVE_STRING_H */
#include <sys/types.h>
#include <sys/socket.h>   

#define NAME "Sendmail overwrite feature"
#define DESC "\
Some versions of sendmail allow a remote user to send a mail\n\
directly to a non-root owned file. This feature can be used to \n\
overwrite a '.rhost' file of a user or whatever...\n\n\
Risk factor : High"
#define COPYRIGHT "no copyright"
#define SUMM "send a mail to a file"




int plugin_init(struct arglist *desc);
int plugin_init(struct arglist *desc)
{
	plug_set_name(desc, NAME);
	plug_set_description(desc, DESC);
	plug_set_summary(desc, SUMM);
	plug_set_copyright(desc, COPYRIGHT);
	plug_set_category(desc, ACT_GATHER_INFO);
	plug_set_family(desc, "Sendmail");
	return(0);
}
	
void getline(int soc, char * buf)
{
 int i = 0;
 char c;
 int flag = 0;

 bzero(buf, 2048);
 while(!flag)
 {
  read(soc, &c, 1);
  buf[i++] = c;
  if(c==0 || c=='\n' || i>2046)flag = 1;
 }
}     



int plugin_run(struct arglist * args);	
int plugin_run(struct arglist * args)
{
	int soc;
	char * buf;
	int i;
	
	
	if(host_get_port_state(args, 25)<=0)return(0);
	soc = open_sock_tcp(args, 25);
	if(soc<0)return(-1);
	buf = emalloc(2048);
	getline(soc, buf);
	sprintf(buf, "mail from: nessus\n");
	send(soc, buf, strlen(buf),0);
	getline(soc, buf);
	
	sprintf(buf, "rcpt to: /tmp/.tst\n");
	send(soc, buf, strlen(buf),0);
	getline(soc, buf);
	for(i=0;i<strlen(buf);i++)
	 buf[i]=tolower(buf[i]);
	
	if(!strncmp(buf, "250 ", 4))
	{
	sprintf(buf, "data\nnessus-generated test file\n.\nquit\n");
	send(soc, buf, strlen(buf), 0);
	 post_hole(args, 25,
"Sendmail allows a remote user to write directly to a file\n\
which is very dangerous.\n\n\
Solution : upgrade");
 	}
	sprintf(buf, "quit\n");
	send(soc, buf, strlen(buf),0);
	close(soc);
	efree(buf);
	return(0);
}
